/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.common.security.component;

import com.evasion.common.Utils;
import java.io.IOException;
import javax.faces.component.FacesComponent;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanWrapperImpl;
import org.springframework.beans.BeansException;

/**
 *
 * @author sebastien.glon
 */
@FacesComponent(value = "com.evasion.common.security.component.AuthenticationTag")
public class AuthenticationTag extends UIOutput {

    /**
     * LOGGER.
     */
    private static final Logger LOGGER = LoggerFactory.getLogger(
            AuthenticationTag.class);

    public AuthenticationTag() {
        super();
    }

    @Override
    public String getFamily() {
        return "com.evasion";
    }

    protected enum PropertyKeys {

        property;

        String toString;

        PropertyKeys(String toString) {
            this.toString = toString;
        }

        PropertyKeys() {
        }

        @Override
        public String toString() {
            return ((toString != null) ? toString : super.toString());
        }
    }

    private String getProperty() {
        return (String) this.getAttributes().get(PropertyKeys.property.toString());
    }

    @Override
    public void encodeBegin(FacesContext context) throws IOException {
        ResponseWriter writer = context.getResponseWriter();
        if (getValue() != null) {
            if (getConverter() == null) {
                writer.write(getValue().toString());
            } else {
                writer.write((String) getConverter().getAsString(context, this, getValue()));
            }
        }
    }

    @Override
    public Object getValue() {
        Object result = super.getValue();
        if (getProperty() != null && Utils.getPrincipal() != null) {

            try {


                BeanWrapperImpl wrapper = new BeanWrapperImpl(Utils.getPrincipal());
                result = wrapper.getPropertyValue(getProperty());
                LOGGER.debug("recherche de la propriete {} dans le UserPrincipal: {}", getProperty(), result);
            } catch (BeansException e) {
                throw new javax.faces.FacesException(e);
            }
        }
        return result;
    }
}
